#include <stdio.h>
#include <stdlib.h>
#include "omp.h"

#define N 10
#define NUMBER_OF_THREADS 2

int main(int argc, char *argv[])
{
    int x[N], sum = 10, max_value = 1000;
    int i;

    for( i = 0; i < N; i++ )
        x[i] = i;

    #pragma omp parallel reduction(+:sum) \
        reduction(max:max_value) //private(sum)
    {
        int id = omp_get_thread_num();
        int nths = omp_get_num_threads();
        for ( i = id; i < N; i+=nths )
        {
            sum += x[i];
            max_value = max_value > i ? max_value : i;
        }
    }

    printf("Sum is: %d\n", sum);
    printf("Maximum is: %d\n", max_value);

    return 0;
}

